unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, TeeProcs, TeEngine, Chart, StdCtrls, Menus, Series;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    MFile: TMenuItem;
    MCreate: TMenuItem;
    MOpen: TMenuItem;
    MSave: TMenuItem;
    N5: TMenuItem;
    MExit: TMenuItem;
    MDiagram: TMenuItem;
    MBuild: TMenuItem;
    MHelp: TMenuItem;
    MAbout: TMenuItem;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Memo1: TMemo;
    Chart1: TChart;
    Series1: TLineSeries;
    MClearDiagram: TMenuItem;
    procedure MAboutClick(Sender: TObject);
    procedure MCreateClick(Sender: TObject);
    procedure Memo1Change(Sender: TObject);
    procedure MSaveClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MOpenClick(Sender: TObject);
    procedure MBuildClick(Sender: TObject);
    procedure MExitClick(Sender: TObject);
    procedure MClearDiagramClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation
uses About;
var s,sf:String;
unSaved:boolean;
f:textfile;

{$R *.DFM}

procedure TForm1.MAboutClick(Sender: TObject);
begin
 AboutBox.ShowModal;
end;

procedure TForm1.MCreateClick(Sender: TObject);
begin
 if unSaved=true then begin
  if MessageDlg('    ?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then MSaveClick(Form1);
 end;
 Memo1.Lines.Clear;
 MClearDiagramClick(Form1);
 MSave.Enabled:=False;
 MBuild.Enabled:=False;
 unSaved:=False;
end;

procedure TForm1.Memo1Change(Sender: TObject);
begin
 MSave.Enabled:=True;
 MBuild.Enabled:=True;
 unSaved:=True;
end;

procedure TForm1.MSaveClick(Sender: TObject);
begin
 if SaveDialog1.Execute then begin
  sf:=ChangeFileExt(SaveDialog1.FileName, '.txt');
  if Length(sf)=4 then Exit;
  if FileExists(sf) then
   if MessageDlg('   ' + ExtractFileName(sf) + '?',
      mtConfirmation, [mbYes, mbNo], 0) <> mrYes then exit;
  try
   AssignFile (f,sf);
   {$I-}ReWrite (f);{$I+}
   if IoResult<>0 then begin
    ShowMessage ('   '+sf+'  .   ,             ');
    unSaved:=True;
    exit;
   end;
  except
   on EFOpenError do begin
    exit;
   end;
  end;
  CloseFile (f);
  Memo1.Lines.SaveToFile (sf);
  s:=ExtractFilePath(sf);
  if Length(s)<1 then s:=' ';
  ShowMessage (' '+ ExtractFileName(sf) + '   '+s);
  unSaved:=False;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
 unSaved:=false;
end;

procedure TForm1.MOpenClick(Sender: TObject);
begin
 if unSaved=true then begin
  if MessageDlg('    ?',
      mtConfirmation, [mbYes, mbNo], 0) = mrYes then MSaveClick(Form1);
 end;
 if OpenDialog1.Execute then begin
  try
   Memo1.Lines.LoadFromFile (OpenDialog1.Filename);
  except
   on EFOpenError do begin
    ShowMessage ('   '+OpenDialog1.Filename);
    exit;
   end;
  end;
  unSaved:=False;
 end;
end;

function DeleteSpaces(var s:string):string;
var p:integer; {  }
begin
 repeat
  p:=pos('  ',s);
  if p>0 then delete (s,p,1);
 until p=0;
 if s[1]=' ' then delete (s,1,1);
 if s[length(s)]=' ' then delete (s,length(s),1);
 DeleteSpaces:=s;
end;

procedure TForm1.MBuildClick(Sender: TObject);
var i,p,code:integer; x,y:real;
s,s1,s2,si1:string;
begin
 if Memo1.Lines.Count<1 then begin
  ShowMessage ('    1  !');
  Exit;
 end;
 for i:=0 to Memo1.Lines.Count-1 do begin
  str (i+1,si1);
  s:=Memo1.Lines[i];
  s:=DeleteSpaces (s);
  p:=pos (' ',s);
  if p>0 then begin
   s1:=copy (s,1,p-1);
   delete (s,1,p);
   s2:=s;
  end
  else begin
   ShowMessage ('   '+si1+' -  2 ,  ');
   exit;
  end;
  {$R-} Val (s1,x,code); {$R+}
  if code<>0 then begin
   ShowMessage ('   '+si1+' -    X');
   exit;
  end;
  {$R-} Val (s2,y,code); {$R+}
  if code<>0 then begin
   ShowMessage ('   '+si1+' -    Y');
   exit;
  end;
  Chart1.Series[0].AddXY (x,y,'',clRed);
 end;
 Chart1.Draw(Form1.Canvas,Chart1.GetRectangle);
end;

procedure TForm1.MExitClick(Sender: TObject);
begin
 Application.Terminate;
end;

procedure TForm1.MClearDiagramClick(Sender: TObject);
begin
 Chart1.Series[0].Clear;
end;

end.
